/*
 * C
 *
 * Copyright 2020 MicroEJ Corp. All rights reserved.
 * This library is provided in source code for use, modification and test, subject to license terms.
 * Any modification of the source code will break MicroEJ Corp. warranties on the whole library.
 */

#if !defined DISPLAY_UTILS_H
#define DISPLAY_UTILS_H

#include "LLUI_PAINTER_impl.h"

// -----------------------------------------------------------------------------
// Macros and Defines
// -----------------------------------------------------------------------------

/*
 * @brief Unknown resource format
 */
#define DISPLAY_UNKNOWN_FORMAT		-1

/*
 * @brief Unknown resource format
 */
#define DISPLAY_DEFAULT_BPP			16
// -----------------------------------------------------------------------------
// Public functions
// -----------------------------------------------------------------------------

/*
 * @brief Returns the bit per pixel from a MicroUI image format
 *
 * @param[in] image_format: The MicroUI format of the image
 *
 * @return The bit per pixel of the image, or -1 if the image format is unknown
 */
int32_t display_utils_get_bpp(MICROUI_ImageFormat image_format);

#endif // !defined DISPLAY_UTILS_H

// -----------------------------------------------------------------------------
// EOF
// -----------------------------------------------------------------------------

