/*
 * C
 *
 * Copyright 2020 MicroEJ Corp. All rights reserved.
 * This library is provided in source code for use, modification and test, subject to license terms.
 * Any modification of the source code will break MicroEJ Corp. warranties on the whole library.
 */

#if !defined __LLVGLITE_IMPL_H__
#define __LLVGLITE_IMPL_H__

#include <stdint.h>

#if defined __cplusplus
extern "C" {
#endif

/*
 * @brief Macros to declare MicroUI native functions
 */
#define LLVGLITE_NATIVE_PREFIX Java_com_verisilicon_vivante_Nvg_1lite_vg_1lite_1
#define LLVGLITE_NATIVE(fn, ...) CONCAT_FUNCTION(LLVGLITE_NATIVE_PREFIX, fn, __VA_ARGS__)
#define LLVGLITE_MATRIX_NATIVE_PREFIX Java_com_verisilicon_vivante_Nvg_1lite_1matrix_
#define LLVGLITE_MATRIX_NATIVE(fn, ...) CONCAT_FUNCTION(LLVGLITE_MATRIX_NATIVE_PREFIX, fn, __VA_ARGS__)
#define LLVGLITE_MATRIX_OBJECT_PREFIX Java_com_verisilicon_vivante_Nvg_1lite_1matrix_
#define LLVGLITE_MATRIX_OBJECT(fn, ...) CONCAT_FUNCTION(LLVGLITE_MATRIX_OBJECT_PREFIX, fn, __VA_ARGS__)
#define LLVGLITE_GRADIENT_OBJECT_PREFIX Java_com_verisilicon_vivante_Nvg_1lite_1gradient_
#define LLVGLITE_GRADIENT_OBJECT(fn, ...) CONCAT_FUNCTION(LLVGLITE_GRADIENT_OBJECT_PREFIX, fn, __VA_ARGS__)

#define LLVGLITE_NATIVE_NAME(fn) (CONCAT_DEFINES(LLVGLITE_NATIVE_PREFIX, fn))

#ifdef __cplusplus
}
#endif

#endif // !defined __LLVGLITE_IMPL_H__
