/*
 * Java
 *
 * Copyright 2020 MicroEJ Corp. All rights reserved.
 * This library is provided in source code for use, modification and test, subject to license terms.
 * Any modification of the source code will break MicroEJ Corp. warranties on the whole library.
 */
package com.microej.service;

/**
 * The {@link PowerService} natives implementation.
 */
public class PowerServiceNative {

	/**
	 * Returns the current power level to the application.
	 *
	 * @return the power level in percent
	 */
	public static int getPowerLevel() {
		return PowerService.INSTANCE.getPowerLevel();
	}

	/**
	 * Returns the charge mode to the application.
	 *
	 * @return true is the battery is charging, false otherwise
	 */
	public static boolean isCharging() {
		return PowerService.INSTANCE.isCharging();
	}
}
