/*
 * Java
 *
 * Copyright 2021 MicroEJ Corp. All rights reserved.
 * Use of this source code is governed by a BSD-style license that can be found with this software.
 */
package com.microej.demo.watch.watchface.flowerlp;

import com.microej.demo.watch.util.KernelServiceRegistry;
import com.microej.demo.watch.util.services.NavigationService;

import ej.kf.FeatureEntryPoint;

/**
 * Entry point of the KF application.
 */
public class FlowerLPWatchfaceEntryPoint implements FeatureEntryPoint {

	@Override
	public void start() {
		NavigationService navigationService = KernelServiceRegistry.getServiceLoader()
				.getService(NavigationService.class);
		navigationService.registerWatchface(new FlowerLPWatchfaceApp());
	}

	@Override
	public void stop() {
		// do nothing
	}
}
