/*
 * Java
 *
 * Copyright 2016 IS2T. All rights reserved.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.giml.generator.test;

import java.io.InputStream;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Map;

import org.junit.Ignore;

import com.is2t.giml.description.Description;
import com.is2t.giml.description.Type;
import com.is2t.giml.description.Type.Basetype;

@Ignore
public class NodeWithNotOrderedElementsDescription implements Description {

	static final String TAG = "dock";
	private static final String CLASS_NAME = "ej.container.Dock";
	private static final String HORIZONTAL_ATTRIBUTE = "horizontal";
	private static final String FIRST = "first";
	private static final String CENTER = "center";
	private static final String LAST = "last";

	@Override
	public boolean isRoot() {
		return false;
	}

	@Override
	public Type getAttributeType(String attributeName) {
		switch (attributeName.toLowerCase()) {
		case HORIZONTAL_ATTRIBUTE:
			return Type.BOOLEAN;
		default:
			throw new IllegalArgumentException();
		}
	}

	@Override
	public void generateInitialization(String variableName, Map<String, String> attributes, StringWriter writer) {
		// not tested
	}

	@Override
	public Object newInstance(ClassLoader arg0, Map<String, Object> arg1) throws ReflectiveOperationException {
		// not tested
		return null;
	}

	@Override
	public boolean hasOrderedElements() {
		return false;
	}

	@Override
	public String getDefaultElement() {
		return null;
	}

	@Override
	public Collection<String> getElements() {
		ArrayList<String> list = new ArrayList<String>();
		list.add(FIRST);
		list.add(CENTER);
		list.add(LAST);
		return list;
	}

	@Override
	public Type getElementType(String elementName) {
		return new Type(Basetype.Object, "ej.mwt.Widget");
	}

	@Override
	public Type getElementAttributeType(String elementName, String attributeName) {
		throw new IllegalArgumentException();
	}

	@Override
	public int getElementMaxCardinality(String elementName) {
		switch (elementName) {
		case FIRST:
		case CENTER:
		case LAST:
			return 1;
		default:
			throw new IllegalArgumentException();
		}
	}

	@Override
	public void generateChild(String variableName, String elementName, Map<String, String> attributes,
			String childVariableName, StringWriter writer) {
		writer.append(variableName).append('.');
		switch (elementName.toLowerCase()) {
		case FIRST:
			writer.append("setFirst");
			break;
		case CENTER:
			writer.append("setCenter");
			break;
		case LAST:
			writer.append("setLast");
			break;
		default:
			throw new IllegalArgumentException();
		}
		writer.append("(").append(childVariableName).append(");\n");

	}

	@Override
	public void addChild(ClassLoader arg0, Object arg1, String arg2, Map<String, Object> arg3, Object arg4)
			throws ReflectiveOperationException {
		// not tested
	}

	@Override
	public Collection<String> getElementAttributes(String elementName) {
		// not tested
		return Collections.emptyList();
	}

	@Override
	public String getClassName() {
		return CLASS_NAME;
	}

	@Override
	public String getFriendlyName() {
		return TAG;
	}

	@Override
	public String getDescription() {
		return TAG;
	}

	@Override
	public InputStream getIcon16() {
		return null;
	}

	@Override
	public InputStream getIcon24() {
		return null;
	}

	@Override
	public String getTag() {
		return TAG;
	}

	@Override
	public boolean isRequiredAttribute(String attributeName) {
		if (HORIZONTAL_ATTRIBUTE.equalsIgnoreCase(attributeName)) {
			return false;
		}
		throw new IllegalArgumentException();
	}

	@Override
	public Collection<String> getAttributes() {
		ArrayList<String> list = new ArrayList<String>();
		list.add(HORIZONTAL_ATTRIBUTE);
		return list;
	}

}
