/*
 * Java
 *
 * Copyright 2019 MicroEJ Corp. All rights reserved.
 * MicroEJ Corp. PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.giml.jsgenerator.nodes;

/**
 * Inline JavaScript code (without function)
 */
public class InlinedCode {

	private final String source;
	private final String functionName;

	public InlinedCode(String source, String functionName) {
		this.source = source;
		this.functionName = functionName;
	}

	/**
	 * Gets the functionName.
	 *
	 * @return the functionName.
	 */
	public String getFunctionName() {
		return functionName;
	}

	/**
	 * Gets the source code.
	 *
	 * @return the source code.
	 */
	public String getSource() {
		return source;
	}
}
