package com.is2t.java.nodes;

import com.is2t.java.JavaSourceGenerator;

/**
 * Java Statement like :
 * 		if ( condition)	ifTrue else ifFalse
 * 		
 * Java
 *
 * Copyright 2008 IS2T. All rights reserved
 * IS2T PROPRIETARY/ Use is subject to license terms.
 */
public class IfStatement extends Statement {
	
	//Almost ifTrue or ifFalse are not null !
	public Statement ifTrue;		//may be null
	public Statement ifFalse;		//may be null
	public Expression condition;	//not null
	
	public IfStatement( Expression condition, Statement ifTrue, Statement ifFalse) {
		this.ifTrue = ifTrue;
		this.ifFalse = ifFalse;
		this.condition = condition;
	}
	
	public IfStatement( Expression condition, Statement ifTrue ) {
		this.ifTrue = ifTrue;
		this.condition = condition;
	}
		
	
	@Override
	public void generateUsing(JavaSourceGenerator gen) {
		gen.generateIfStatement( this);
	}
	
}
