package com.is2t.java.nodes;

import com.is2t.java.JavaSourceGenerator;

public class InterfaceDeclaration extends TypeDeclaration {

	public InterfaceDeclaration(char[][] fullyQualifiedName) {
		super(fullyQualifiedName);
	}

	@Override
	public void generateUsing(JavaSourceGenerator gen) {
		gen.generateInterfaceDeclaration( this);
		
	}
	
	public boolean isInterface() {
		return true;
	}

	/**
	 * search method in hierarchy
	 * Null if not found : no existing method or pre-existing method (like Object.hascode())!
	 */
	public AbstractMethodDeclaration lookForMethodAt( char[] name, TypeReference[] argsType) {
		AbstractMethodDeclaration method =super.lookForMethodAt(name, argsType);
		if ( method != null)
			return method;
		
		//look in super interfaces
		for (int i = interfaces.length; --i >=0; ) {
			if ( ! interfaces[i].isPreExistingTypeOrArray()) {
				method = interfaces[i].declaration.lookForMethodAt( name, argsType);
				if ( method !=  null)
					return method;
			}
		}
		return null;
	}
}
