package com.is2t.java.nodes.expressions;

import com.is2t.java.JavaSourceGenerator;
import com.is2t.java.nodes.Expression;

/**
 * Java Expression :
 * 		 left = right;
 *
 * Copyright 2008 IS2T. All rights reserved
 * IS2T PROPRIETARY/ Use is subject to license terms.
 */
public class Assignment extends Expression {
	
	public Expression left;
	public Expression right;
	
	public Assignment(Expression left, Expression right){
		// sanitycheck
		if(!(left instanceof LocalAccess || left instanceof FieldAccess || left instanceof ArrayAccess)) throw new RuntimeException();
		this.left = left;
		this.right = right;
	}

	@Override
	public void generateExpressionUsing(JavaSourceGenerator gen) {
		gen.generateAssignment( this);
	}
	
}
